set 
  search_path = 'public';
drop 
  table sales;
create table sales (
  id serial primary key, 
  employee_name varchar(100), 
  sale_amount decimal
);
insert into sales (employee_name, sale_amount) 
values 
  ('john', 500), 
  ('jane', 1200), 
  ('john', 800), 
  ('jane', 100), 
  ('alice', 700), 
  ('bob', 300), 
  ('john', 450), 
  ('alice', 1000), 
  ('jane', 950), 
  ('bob', 200);
select 
  * 
from 
  sales;
-- row_number()
select 
  employee_name, 
  sale_amount, 
  row_number() over (
    order by 
      sale_amount desc
  ) as row_num 
from 
  sales;
-- rank()
select 
  employee_name, 
  sale_amount, 
  rank() over (
    order by 
      sale_amount desc
  ) as rank_num 
from 
  sales;
-- dense_rank()
select 
  employee_name, 
  sale_amount, 
  dense_rank() over (
    order by 
      sale_amount desc
  ) as dense_rank_num 
from 
  sales;
-- sum()
select 
  employee_name, 
  sale_amount, 
  sum(sale_amount) over (
    partition by employee_name 
    order by 
      sale_amount desc
  ) as cumulative_sales 
from 
  sales;
-- avg()
select 
  employee_name, 
  sale_amount, 
  avg(sale_amount) over (partition by employee_name) as avg_sales 
from 
  sales;
-- lead()
select 
  employee_name, 
  sale_amount, 
  lead(sale_amount, 1) over (
    order by 
      sale_amount desc
  ) as next_sale 
from 
  sales;
-- lag()
select 
  employee_name, 
  sale_amount, 
  lag(sale_amount, 1) over (
    order by 
      sale_amount desc
  ) as previous_sale 
from 
  sales;
